$! make gnuplot 3.6 beta under OpenVMS
$! based on buildvms.com from Gnuplot 3.5/3.6 beta 
$!
$! In case of problems with the install you might contact me at
$! zinser@decus.decus.de(preferred) or martin_zinser@exchange.de
$!
$! Usage: @MAKE_VMS P1 [P2]
$!    P1 = compiler ("DECC" or "VAXC" or "GNUC")
$!         default is to autodetect the compiler
$!    P2 = special make file (eg. for testing), default is "DESCRIP.MMS"
$!    P3 = built with GIF support, location of headerfile and library, 
$!         e.g. public$Root[util.libs.gd],pubbin:libgd.olb
$!         default is no GIF support
$!    P4 = built with PNG support, location of headerfile and library (first PNG, then zlib), 
$!         e.g. public$Root:[util.libs.libpng],pubbin:libpng.olb,public$Root:[util.libs.zlib],pubbin:zlib.olb
$!         default is no PNG support
$!    P5 = ALL Full build with tex and HTML documentation
$!         Default is Images and HLB only
$!
$ set noon
$!
$ Make = ""
$!
$! Check for MMK/MMS
$!
$ If F$Search ("Sys$System:MMS.EXE") .nes. "" Then Make = "MMS"
$ If F$Type (MMK) .eqs. "STRING" Then Make = "MMK"
$!
$! detect compiler - drd
$! if DECC is around, assume that, else gcc is preferred. Finally vaxc
$!
$ its_decc = (f$search("SYS$SYSTEM:DECC$COMPILER.EXE") .nes. "")
$ its_gnuc = .not.its_decc .and. (f$trnlnm("gnu_cc").nes."")
$ its_vaxc = .not. (its_decc .or. its_gnuc)
$!
$ P1 = F$EDIT(P1,"UPCASE") 
$ if p1.eqs."DECC" 
$   then 
$    its_decc = 1
$    its_gnuc = 0
$    its_vaxc = 0
$ else
$   if p1.eqs."VAXC"
$     then
$      its_decc = 0
$      its_gnuc = 0
$      its_vaxc = 1
$   else
$     if p1.eqs."GNUC"
$      then
$        its_decc = 0
$        its_gnuc = 1
$        its_vaxc = 0
$     endif
$   endif
$ endif
$!
$ if (its_decc)
$ then
$   COMP = "CC=CC"
$   csfl = "ANSI_C,HAVE_UNISTD_H,HAVE_GETCWD,DECCRTL"
$ endif
$ if (its_vaxc)
$ then
$   COMP = "CC=CC"
$   csfl = "NO_LOCALE_H,VAXCRTL"
$ endif
$ if (its_gnuc)
$ then
$   COMP = "CC=GCC"
$   csfl = "ANSI_C,NO_LOCALE_H,VAXCRTL"
$ endif
$!
$ if p3.nes.""
$  then
$   gdinc = f$element(0,",",p3)
$   gdlib = f$element(1,",",p3)
$   gddef = ",HAVE_LIBGD"
$   define gd 'gdinc
$ else
$   gdinc = ""
$   gdlib = ""
$ endif
$!
$ if p4.nes.""
$  then
$   pnginc  = f$element(0,",",p4)
$   pnglib  = f$element(1,",",p4)
$   zlibinc = f$element(2,",",p4)
$   zlib    = f$element(3,",",p4)
$   pngdef  = ",HAVE_LIBPNG"
$   define png 'pnginc
$   define zl 'zlibinc
$ else
$   pnginc = ""
$   pnglib = ""
$ endif
$ its_decw = (f$trnlnm("DECW$INCLUDE") .nes. "") 
$ if its_DECW
$ then
$   cx11fl=",X11"
$ else
$   cx11fl=""
$ endif
$!
$! Look for the platform used
$!
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  csfl = csfl + ",HAVE_LGAMMA,HAVE_ERF"
$  o = "abj"
$  x = "axe"
$  arch = "AXP=1"
$ else
$  o = "obj"
$  x = "exe"
$  arch = "VAX=1"
$ endif
$!
$ CFLAGS = "/DEF=(''csfl',NO_GIH,PIPES''cx11fl'''gddef'''pngdef')"
$!
$ TERMFLAGS = "/INCLUDE=(sys$disk:[],[.term]"
$ if (gdinc.nes."") then termflags = termflags + ",GD"
$ if (pnginc.nes."") then termflags = termflags + ",PNG,ZL"
$ termflags = termflags + ")"
$!
$ if ((its_decw).and.(f$trnlnm("X11").eqs."")) then - 
    DEFINE/NOLOG X11 DECW$INCLUDE
$ if f$trnlnm("SYS").eqs."" then DEFINE SYS SYS$LIBRARY
$!
$! Create the option files
$!
$ open/write optf gnuplot.opt
$ write optf "ALLOC.''o'"
$ write optf "BINARY.''o'"
$ write optf "BITMAP.''o'"
$ write optf "COMMAND.''o'"
$ write optf "CONTOUR.''o'"
$ write optf "DATAFILE.''o'"
$ write optf "EVAL.''o'"
$ write optf "FIT.''o'"
$ write optf "GRAPHICS.''o'"
$ write optf "GRAPH3D.''o'"
$ write optf "HELP.''o'"
$ write optf "HIDDEN3D.''o'"
$ write optf "INTERNAL.''o'"
$ write optf "INTERPOL.''o'"
$ write optf "MATRIX.''o'"
$ write optf "MISC.''o'"
$ write optf "PARSE.''o'"
$ write optf "PLOT.''o'"
$ write optf "PLOT2D.''o'"
$ write optf "PLOT3D.''o'"
$ write optf "READLINE.''o'"
$ write optf "SCANNER.''o'"
$ write optf "SET.''o'"
$ write optf "SHOW.''o'"
$ write optf "SPECFUN.''o'"
$ write optf "STANDARD.''o'"
$ write optf "STDFN.''o'"
$ write optf "TERM.''o'"
$ write optf "TIME.''o'"
$ write optf "UTIL.''o'"
$ write optf "UTIL3D.''o'"
$ write optf "VERSION.''o'"
$ write optf "VMS.''o'"  
$ write optf "Identification=""Gnuplot 3.6-347"""
$ if (gdlib.nes."") then write optf "''gdlib'/lib"
$ if (pnglib.nes."") 
$  then 
$   write optf "''pnglib'/lib"
$   write optf "''zlib'/lib"
$ endif
$ open/write uoptf util.opt
$ open/write xoptf x11vms.opt
$!
$! Add some compiler specific stuff
$!
$ if its_gnuc
$ then CFLAGS="''cflags'/nocase"
$      write optf "GNU_CC:[000000]GCCLIB/LIB"
$      write uoptf "GNU_CC:[000000]GCCLIB/LIB"
$      write xoptf "GNU_CC:[000000]GCCLIB/LIB"
$ endif
$!
$ if its_decc
$ then CFLAGS="''cflags'/pref=all/warn=disable=ADDRCONSTEXT"
$ else 
$   write optf "sys$library:vaxcrtl/share"
$   write uoptf "sys$library:vaxcrtl/share"
$   write xoptf "sys$library:vaxcrtl/share"
$ endif
$!
$ write xoptf "SYS$SHARE:DECW$XLIBSHR/SHARE" 
$ close optf
$ close uoptf
$ close xoptf
$ write sys$output "Compiling Gnuplot sources ..."
$ if (Make.eqs."")
$  then
$   call make alloc.'o "CC/obj=alloc.''o' ''cflags' alloc" -
    	      alloc.c
$   call make binary.'o "CC/obj=binary.''o' ''cflags' binary" -
    	      binary.c
$   call make bitmap.'o "CC/obj=bitmap.''o' ''cflags' bitmap" -
    	      bitmap.c
$   call make command.'o "CC/obj=command.''o' ''cflags' command" -
    	      command.c
$   call make contour.'o "CC/obj=contour.''o' ''cflags' contour" -
    	      contour.c
$   call make datafile.'o "CC/obj=datafile.''o' ''cflags' datafile" -
    	      datafile.c
$   call make eval.'o "CC/obj=eval.''o' ''cflags' eval" -
    	      eval.c
$   call make fit.'o "CC/obj=fit.''o' ''cflags' fit" -
    	      fit.c
$   call make graphics.'o "CC/obj=graphics.''o' ''cflags' graphics" -
    	      graphics.c
$   call make graph3d.'o "CC/obj=graph3d.''o' ''cflags' graph3d" -
    	      graph3d.c
$   call make help.'o "CC/obj=help.''o' ''cflags' help" -
    	      help.c
$   call make hidden3d.'o "CC/obj=hidden3d.''o' ''cflags' hidden3d" -
    	      hidden3d.c
$   call make internal.'o "CC/obj=internal.''o' ''cflags' internal" -
    	      internal.c
$   call make interpol.'o "CC/obj=interpol.''o' ''cflags' interpol" -
    	      interpol.c
$   call make matrix.'o "CC/obj=matrix.''o' ''cflags' matrix" -
    	      matrix.c
$   call make misc.'o "CC/obj=misc.''o' ''cflags' misc" -
    	      misc.c
$   call make parse.'o "CC/obj=parse.''o' ''cflags' parse" -
    	      parse.c
$   call make plot.'o "CC/obj=plot.''o' ''cflags' plot" -
    	      plot.c
$   call make plot2d.'o "CC/obj=plot2d.''o' ''cflags' plot2d" -
    	      plot2d.c
$   call make plot3d.'o "CC/obj=plot3d.''o' ''cflags' plot3d" -
    	      plot3d.c
$   call make readline.'o "CC/obj=readline.''o' ''cflags' readline" -
    	      readline.c
$   call make scanner.'o "CC/obj=scanner.''o' ''cflags' scanner" -
    	      scanner.c
$   call make set.'o "CC/obj=set.''o' ''cflags' set" -
    	      set.c
$   call make show.'o "CC/obj=show.''o' ''cflags' show" -
    	      show.c
$   call make specfun.'o "CC/obj=specfun.''o' ''cflags' specfun" -
    	      specfun.c
$   call make standard.'o "CC/obj=standard.''o' ''cflags' standard" -
    	      standard.c
$   call make stdfn.'o "CC/obj=stdfn.''o' ''cflags' stdfn" -
    	      stdfn.c
$   call make term.'o "CC/obj=term.''o' ''cflags' ''termflags' term" -
    	      term.c
$   call make time.'o "CC/obj=time.''o' ''cflags' time" -
    	      time.c
$   call make util.'o "CC/obj=util.''o' ''cflags' util" -
    	      util.c
$   call make util3d.'o "CC/obj=util3d.''o' ''cflags' util3d" -
    	      util3d.c
$   call make version.'o "CC/obj=version.''o' ''cflags' version" -
    	      version.c
$   call make vms.'o "CC/obj=vms.''o' ''cflags' vms" -
    	      vms.c
$   call make gnuplot.'x "link/exe=gnuplot.''x' gnuplot.opt/opt" *.'o
$   call make bf_test.'o "CC/obj=bf_test.''o' ''cflags' bf_test" -
    	      bf_test.c
$   call make bf_test.'x -
      "link/exe=bf_test.''x'  bf_test.''o',binary.''o',alloc.''o',util.opt/opt" -
      bf_test.'o binary.'o alloc.'o
$   ren bf_test.'x [.demo]
$   run [.demo]bf_test.'x
$   if (its_decw)
$   then
$     call make GPLT_X11.'o "CC/obj=GPLT_X11.''o' ''cflags' GPLT_X11" -
    	        GPLT_X11.c
$     call make gnuplot_x11.'x "link/exe=gnuplot_x11.''x' gplt_x11.'o,x11vms.opt/opt" -
                gplt_x11.'o
$   endif
$!
$   SET DEF [.DOCS]
$   call make [-]doc2hlp.'o -
    	      "CC/obj=[-]doc2hlp.''o' ''cflags'/include=([-],[-.term]) doc2hlp" -
    	      doc2hlp.c
$   SET DEF [-]
$   call make doc2hlp.'x "link/exe=doc2hlp.''x' doc2hlp.'o,util.opt/opt" -
    	      doc2hlp.'o
$   doc2hlp := $sys$disk:[]doc2hlp.'x
$   doc2hlp [.docs]gnuplot.doc gnuplot.hlp
$   library/create/help sys$disk:[]gnuplot.hlb gnuplot.hlp
$   if (f$edit(p5,"upcase").eqs."ALL")
$   then
$     SET DEF [.DOCS]
$     call make [-]doc2tex.'o -
        	"CC/obj=[-]doc2tex.''o' ''cflags'/include=([-],[-.term]) doc2tex" -
        	doc2tex.c
$     SET DEF [-]
$     call make doc2tex.'x "link/exe=doc2tex.''x' doc2tex.'o,util.opt/opt" -
        	doc2tex.'o
$     doc2tex := $sys$disk:[]doc2tex.'x
$     doc2tex [.docs]gnuplot.doc gnuplot.tex
$     SET DEF [.DOCS]
$     call make [-]doc2html.'o -
        	"CC/obj=[-]doc2html.''o' ''cflags'/include=([-],[-.term]) doc2html" -
        	doc2html.c
$     SET DEF [-]
$     call make doc2html.'x "link/exe=doc2html.''x' doc2html.'o,util.opt/opt" -
        	doc2html.'o
$     doc2html := $sys$disk:[]doc2html.'x
$     doc2html [.docs]gnuplot.doc gnuplot.html
$   endif
$ else
$  mmsfile = "descrip.mms"
$  if (p2.nes."") then mmsfile ="'p2'"
$  'Make' /des='mmsfile' -
     /macro=('arch','comp',cflags="''cflags'",termflags="''termflags'") 'p5
$ endif
$ if (its_decw) then -
    write sys$output "%define GNUPLOT_X11 :== $Disk:[directory]GNUPLOT_X11"
$ write sys$output "Gnuplot build completed"
$ exit
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE
